<?php

if (strpos(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

# Set report Type
$options = array ('weekly', 'daily', 'all');
if (!in_array($option, $options))
   die ("Invalid report type");

# Set Entertrack server home
if ($_ENV['root'])
   $root = $_ENV['root'];
elseif ($_POST['root'])
   $root = $_POST['root'];
elseif ($_GET['root'])
   $root = $_GET['root'];


$now = time(); // Get current time


# Set date range for report type
if ($option == "weekly") 
   $to = $now + 604800;
elseif ($option == "daily")
   $to = $now + 86400;

# Get issues owners
$sql  = "select u.userid, u.username, u.primary_email ";
$sql .=	"from issues i, statuses s, users u, issue_groups ig ";
$sql .=	"where i.due_date is not null ";
$sql .=	"and i.issueid = ig.issueid ";
$sql .=	"and ig.assigned_to = u.userid ";
$sql .= "and ig.show_issue = 't' ";
$sql .=	"and i.status = s.sid ";
$sql .=	"and s.status_type not in (5,6) ";
#$sql .= "and u.userid in (56,77) ";
if ($option != "all")
   $sql .= "and (i.due_date < $now or i.due_date between $now and $to) ";
$sql .=	"group by u.userid, u.username, u.primary_email ";
$sql .=	"order by u.username";

$stmt = $_ENV['dbi']->prepare($sql);
$result = $stmt->execute();
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
$users = $result->fetchAll(MDB2_FETCHMODE_ASSOC);
$result->free();
$stmt->free();

# Get issues by user
foreach ($users as $user) {
   if (($userType == 'client' && !is_employee($user['userid'])) || ($userType == 'employee' && is_employee($user['userid']))) { 
   echo "\n {$user['username']}\n";
	$sql  = "select i.issueid, i.severity, g.name as groups, i.summary, i.opened, i.due_date ";
	$sql .= "from issues i, issue_groups ig, groups g, statuses s ";
	$sql .= "where i.issueid = ig.issueid ";
	$sql .= "and ig.gid = g.gid ";
	$sql .= "and i.due_date is not null ";
	$sql .= "and i.status = s.sid ";
	$sql .= "and s.status_type not in (5,6) ";
	$sql .= "and ig.assigned_to = ? ";
	$params[] = $user['userid'];
	if ($option != "all") { 
   	   $sql .= "and (i.due_date < ? or i.due_date between ? and ?) ";
	   $params[] = $now;
	   $params[] = $now;
	   $params[] = $to;
	}
	$sql .= "order by due_date";

	$stmt = $_ENV['dbi']->prepare($sql);
	$result = $stmt->execute($params);
	$_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
	$issues = $result->fetchAll(MDB2_FETCHMODE_ASSOC);
	$result->free();
	$stmt->free();
	unset($params);
	$_ENV['tpl']->assign('user',$user);
	$_ENV['tpl']->assign('issues',$issues);
	$_ENV['tpl']->assign('now',$now);
	$_ENV['tpl']->assign('from', $now);
	$_ENV['tpl']->assign('to', $to);
	$_ENV['tpl']->assign('root', $root);
	$_ENV['tpl']->assign('option', $option);
	$_ENV['tpl']->assign('title', $title);
	$_ENV['tpl']->assign('company', $company);

	$output = $_ENV['tpl']->fetch("reports/automatic/duedate.tpl");
	# Send Email to user
	$hdrs = array(	'From'    => $sender,
			'Subject' => "$company Issues report"
		     );
	$crlf = "\n";
	$mime = new Mail_mime($crlf);
	$mime->setHTMLBody($output);
	$body = $mime->get();
	$hdrs = $mime->headers($hdrs);
	$mail =& Mail::factory('mail');
	$mail->send($user['primary_email'], $hdrs, $body);
	$_ENV['error']->logger("$userType report sent to {$user['primary_email']} - Issues reported ".count($issues),"automaticReports");
   }
}
?>
